'use strict';

exports.__esModule = true;

var _clientFunctionFactory = require('../client-functions/client-function-factory');

var _clientFunctionFactory2 = _interopRequireDefault(_clientFunctionFactory);

var _selectorFactory = require('../client-functions/selector-factory');

var _selectorFactory2 = _interopRequireDefault(_selectorFactory);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
    ClientFunction: function ClientFunction(fn, scopeVars) {
        var factory = new _clientFunctionFactory2.default(fn, scopeVars, { instantiation: 'ClientFunction' });

        return factory.getFunction();
    },
    Selector: function Selector(fn, scopeVars) {
        var factory = new _selectorFactory2.default(fn, scopeVars, { instantiation: 'Selector' });

        return factory.getFunction();
    }
};
module.exports = exports['default'];