'use strict';

exports.__esModule = true;

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

// Validations

var getValidHostname = function () {
    var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(hostname) {
        var valid;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        if (!hostname) {
                            _context.next = 8;
                            break;
                        }

                        _context.next = 3;
                        return endpointUtils.isMyHostname(hostname);

                    case 3:
                        valid = _context.sent;

                        if (valid) {
                            _context.next = 6;
                            break;
                        }

                        throw new _runtime.GeneralError(_message2.default.invalidHostname, hostname);

                    case 6:
                        _context.next = 11;
                        break;

                    case 8:
                        _context.next = 10;
                        return endpointUtils.getMyHostname();

                    case 10:
                        hostname = _context.sent;

                    case 11:
                        return _context.abrupt('return', hostname);

                    case 12:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this);
    }));
    return function getValidHostname(_x) {
        return ref.apply(this, arguments);
    };
}();

var getValidPort = function () {
    var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(port) {
        var isFree;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        if (!port) {
                            _context2.next = 8;
                            break;
                        }

                        _context2.next = 3;
                        return endpointUtils.isFreePort(port);

                    case 3:
                        isFree = _context2.sent;

                        if (isFree) {
                            _context2.next = 6;
                            break;
                        }

                        throw new _runtime.GeneralError(_message2.default.portIsNotFree, port);

                    case 6:
                        _context2.next = 11;
                        break;

                    case 8:
                        _context2.next = 10;
                        return endpointUtils.getFreePort();

                    case 10:
                        port = _context2.sent;

                    case 11:
                        return _context2.abrupt('return', port);

                    case 12:
                    case 'end':
                        return _context2.stop();
                }
            }
        }, _callee2, this);
    }));
    return function getValidPort(_x2) {
        return ref.apply(this, arguments);
    };
}();

// API


var createTestCafe = function () {
    var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(hostname, port1, port2) {
        var _ref;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
            while (1) {
                switch (_context3.prev = _context3.next) {
                    case 0:
                        _context3.next = 2;
                        return _promise2.default.all([getValidHostname(hostname), getValidPort(port1), getValidPort(port2)]);

                    case 2:
                        _ref = _context3.sent;
                        hostname = _ref[0];
                        port1 = _ref[1];
                        port2 = _ref[2];
                        return _context3.abrupt('return', new _testcafe2.default(hostname, port1, port2));

                    case 7:
                    case 'end':
                        return _context3.stop();
                }
            }
        }, _callee3, this);
    }));
    return function createTestCafe(_x3, _x4, _x5) {
        return ref.apply(this, arguments);
    };
}();

// Embedding utils


var _testcafe = require('./testcafe');

var _testcafe2 = _interopRequireDefault(_testcafe);

var _endpointUtils = require('endpoint-utils');

var endpointUtils = _interopRequireWildcard(_endpointUtils);

var _runtime = require('./errors/runtime');

var _message = require('./errors/runtime/message');

var _message2 = _interopRequireDefault(_message);

var _embeddingUtils = require('./embedding-utils');

var _embeddingUtils2 = _interopRequireDefault(_embeddingUtils);

var _common = require('./api/common');

var _common2 = _interopRequireDefault(_common);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

createTestCafe.embeddingUtils = _embeddingUtils2.default;

// Common API
(0, _keys2.default)(_common2.default).forEach(function (key) {
    return createTestCafe[key] = _common2.default[key];
});

exports.default = createTestCafe;
module.exports = exports['default'];