'use strict';

exports.__esModule = true;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _path = require('path');

var _promisify = require('../../utils/promisify');

var _promisify2 = _interopRequireDefault(_promisify);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _testcafeBrowserNatives = require('testcafe-browser-natives');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ensureDir = (0, _promisify2.default)(_mkdirp2.default);

var Capturer = function () {
    function Capturer(baseScreenshotsPath, testScreenshotsPath, testEntry) {
        (0, _classCallCheck3.default)(this, Capturer);

        this.enabled = !!baseScreenshotsPath;
        this.baseScreenshotsPath = baseScreenshotsPath;
        this.testScreenshotsPath = testScreenshotsPath;
        this.testEntry = testEntry;
    }

    Capturer._getFileName = function _getFileName(stepName) {
        return (stepName && stepName.replace(/\s|\\|\/|"|\*|\?|<|>|\|/g, '_') || 'page-load') + '.png';
    };

    Capturer.prototype._takeScreenshot = function () {
        var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(windowId, filePath) {
            return _regenerator2.default.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            _context.next = 2;
                            return ensureDir((0, _path.dirname)(filePath));

                        case 2:
                            _context.next = 4;
                            return (0, _testcafeBrowserNatives.screenshot)(windowId, filePath);

                        case 4:
                            return _context.abrupt('return', filePath);

                        case 5:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, this);
        }));

        function _takeScreenshot(_x, _x2) {
            return ref.apply(this, arguments);
        }

        return _takeScreenshot;
    }();

    Capturer.prototype.captureAction = function () {
        var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(windowId, _ref) {
            var stepName = _ref.stepName;
            var customPath = _ref.customPath;
            var fileName, filePath;
            return _regenerator2.default.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            this.testEntry.screenshotCapturingCalled = true;

                            if (this.enabled) {
                                _context2.next = 3;
                                break;
                            }

                            return _context2.abrupt('return', null);

                        case 3:
                            fileName = Capturer._getFileName(stepName);
                            filePath = customPath ? (0, _path.join)(this.baseScreenshotsPath, customPath, fileName) : (0, _path.join)(this.testScreenshotsPath, fileName);


                            if (customPath) this.testEntry.path = this.baseScreenshotsPath;

                            _context2.next = 8;
                            return this._takeScreenshot(windowId, filePath);

                        case 8:
                            return _context2.abrupt('return', _context2.sent);

                        case 9:
                        case 'end':
                            return _context2.stop();
                    }
                }
            }, _callee2, this);
        }));

        function captureAction(_x3, _x4) {
            return ref.apply(this, arguments);
        }

        return captureAction;
    }();

    Capturer.prototype.captureError = function () {
        var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(windowId, _ref2) {
            var stepName = _ref2.stepName;
            var screenshotRequired = _ref2.screenshotRequired;
            var filePath;
            return _regenerator2.default.wrap(function _callee3$(_context3) {
                while (1) {
                    switch (_context3.prev = _context3.next) {
                        case 0:
                            if (!(!screenshotRequired || !this.enabled)) {
                                _context3.next = 2;
                                break;
                            }

                            return _context3.abrupt('return', null);

                        case 2:
                            filePath = (0, _path.join)(this.testScreenshotsPath, 'errors', Capturer._getFileName(stepName));
                            _context3.next = 5;
                            return this._takeScreenshot(windowId, filePath);

                        case 5:
                            return _context3.abrupt('return', _context3.sent);

                        case 6:
                        case 'end':
                            return _context3.stop();
                    }
                }
            }, _callee3, this);
        }));

        function captureError(_x5, _x6) {
            return ref.apply(this, arguments);
        }

        return captureError;
    }();

    return Capturer;
}();

exports.default = Capturer;
module.exports = exports['default'];