'use strict';

exports.__esModule = true;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _uuid = require('uuid');

var _uuid2 = _interopRequireDefault(_uuid);

var _testcafeBrowserNatives = require('testcafe-browser-natives');

var _warningMessages = require('../runner/screenshots/warning-messages');

var _warningMessages2 = _interopRequireDefault(_warningMessages);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BrowserManipulationManager = function () {
    function BrowserManipulationManager(screenshotCapturer) {
        (0, _classCallCheck3.default)(this, BrowserManipulationManager);

        this.screenshotCapturer = screenshotCapturer;
    }

    BrowserManipulationManager.prototype.takeScreenshot = function () {
        var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(windowId, customPath) {
            return _regenerator2.default.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                        case 0:
                            _context.prev = 0;
                            _context.next = 3;
                            return this.screenshotCapturer.captureAction(windowId, { stepName: _uuid2.default.v4(), customPath: customPath });

                        case 3:
                            return _context.abrupt('return', _context.sent);

                        case 6:
                            _context.prev = 6;
                            _context.t0 = _context['catch'](0);
                            return _context.abrupt('return', null);

                        case 9:
                        case 'end':
                            return _context.stop();
                    }
                }
            }, _callee, this, [[0, 6]]);
        }));

        function takeScreenshot(_x, _x2) {
            return ref.apply(this, arguments);
        }

        return takeScreenshot;
    }();

    BrowserManipulationManager.prototype.takeScreenshotOnFail = function () {
        var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(windowId) {
            return _regenerator2.default.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                        case 0:
                            if (this.screenshotCapturer.enabled) {
                                _context2.next = 2;
                                break;
                            }

                            return _context2.abrupt('return', _warningMessages2.default.screenshotDirNotSet);

                        case 2:
                            _context2.prev = 2;
                            _context2.next = 5;
                            return this.screenshotCapturer.captureError(windowId, { stepName: _uuid2.default.v4(), screenshotRequired: true });

                        case 5:
                            return _context2.abrupt('return', _context2.sent);

                        case 8:
                            _context2.prev = 8;
                            _context2.t0 = _context2['catch'](2);
                            return _context2.abrupt('return', _warningMessages2.default.cannotCreate);

                        case 11:
                        case 'end':
                            return _context2.stop();
                    }
                }
            }, _callee2, this, [[2, 8]]);
        }));

        function takeScreenshotOnFail(_x3) {
            return ref.apply(this, arguments);
        }

        return takeScreenshotOnFail;
    }();

    BrowserManipulationManager.resizeWindow = function () {
        var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(windowId, currentWidth, currentHeight, width, height) {
            return _regenerator2.default.wrap(function _callee3$(_context3) {
                while (1) {
                    switch (_context3.prev = _context3.next) {
                        case 0:
                            _context3.next = 2;
                            return (0, _testcafeBrowserNatives.resize)(windowId, currentWidth, currentHeight, width, height);

                        case 2:
                            return _context3.abrupt('return', _context3.sent);

                        case 3:
                        case 'end':
                            return _context3.stop();
                    }
                }
            }, _callee3, this);
        }));

        function resizeWindow(_x4, _x5, _x6, _x7, _x8) {
            return ref.apply(this, arguments);
        }

        return resizeWindow;
    }();

    BrowserManipulationManager.resizeWindowToFitDevice = function () {
        var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(windowId, currentWidth, currentHeight, device, portrait) {
            var _getViewportSize, landscapeWidth, portraitWidth, width, height;

            return _regenerator2.default.wrap(function _callee4$(_context4) {
                while (1) {
                    switch (_context4.prev = _context4.next) {
                        case 0:
                            _getViewportSize = (0, _testcafeBrowserNatives.getViewportSize)(device);
                            landscapeWidth = _getViewportSize.landscapeWidth;
                            portraitWidth = _getViewportSize.portraitWidth;
                            width = portrait ? portraitWidth : landscapeWidth;
                            height = portrait ? landscapeWidth : portraitWidth;
                            _context4.next = 7;
                            return (0, _testcafeBrowserNatives.resize)(windowId, currentWidth, currentHeight, width, height);

                        case 7:
                            return _context4.abrupt('return', _context4.sent);

                        case 8:
                        case 'end':
                            return _context4.stop();
                    }
                }
            }, _callee4, this);
        }));

        function resizeWindowToFitDevice(_x9, _x10, _x11, _x12, _x13) {
            return ref.apply(this, arguments);
        }

        return resizeWindowToFitDevice;
    }();

    return BrowserManipulationManager;
}();

exports.default = BrowserManipulationManager;
module.exports = exports['default'];